
%Dados do problema
f=inline('atan(3*y)-3*y+t');
y0=1;
%Sistema a resolver em cada passo de Euler implicito
ff=inline('y_new-y_old-h.*(atan(3*y_new)-3*y_new+t_new)');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Passo 1/4
h=1/4;
%Criar vector dos t
t=0:h:6;
%Inicializar vector dos y a zero
y=zeros(size(t));
%Primeiro y  dado
y(1)=y0;
%Aplicar Euler implcito
for i=2:length(t)
    %resolve a equao para determinar o novo y
    y_old=y(i-1);
    t_new=t(i);
    faux=@(y_new)ff(h,t_new,y_new,y_old);
    y(i)=fsolve(faux,y(i-1));
end
%Fazer grfico
plot(t,y,'g')
hold on

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Passo 1/2
h=1/2;
t=0:h:6;
y=zeros(size(t));
y(1)=y0;
for i=2:length(t)
    y_old=y(i-1);
    t_new=t(i);
    faux=@(y_new)ff(h,t_new,y_new,y_old);
    y(i)=fsolve(faux,y(i-1));
end
plot(t,y,'b')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Passo 1
h=1;
t=0:h:6;
y=zeros(size(t));
y(1)=y0;
for i=2:length(t)
    y_old=y(i-1);
    t_new=t(i);
    faux=@(y_new)ff(h,t_new,y_new,y_old);
    y(i)=fsolve(faux,y(i-1));
end
plot(t,y,'r')
hold off

